program main
  use forpy_mod
  implicit none

  integer :: ierror
   type(tuple) :: args
  ! type(dict) :: kwargs
  type(module_py) :: mymodule
  type(object) :: return_value
  type(list) :: paths
  type(dict) :: data


  character(len=:), allocatable :: return_string

  ierror = forpy_initialize()

  ! Instead of setting the environment variable PYTHONPATH,
  ! we can add the current directory "." to sys.path
  ierror = get_sys_path(paths)
  ierror = paths%append(".")
  ! it is assumed that the file hecuba_exporter.py is in the same path where is the compiled code
  ierror = import_py(mymodule, "hecuba_exporter")
  ! it needs to be created even if it is empty
  ierror = tuple_create(args, 0)
  ! passing the vars
  ierror = dict_create(data)
  ierror = data%setitem("name", "surface sea salinity")
  ierror = call_py(return_value, mymodule, "store_data", args, data)
  ierror = cast(return_string, return_value)

  write(*,*) return_string

  ! For call_py, args and kwargs are optional
  ! use call_py_noret to ignore the return value
  ! E. g.:
  ! ierror = call_py_noret(mymodule, "print_args")

  call data%destroy
  call mymodule%destroy
  call return_value%destroy
  call paths%destroy
  call forpy_finalize

end program
